<template>
  <div class="flex flex-col mr-2">
    <input
      v-model="filter"
      class="border mb-2"
      type="text"
    >

    <select
      v-model="selected"
      class="w-full border resize-y"
      multiple
    >
      <option
        v-for="value of values"
        :key="value"
        :value="value"
        :hidden="!isOptionDisplayed(value)"
      >
        {{ value }}
      </option>
    </select>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Model, Prop, Watch } from 'vue-property-decorator'

import _ from 'lodash/fp'

@Component
export default class SetSelector extends Vue {
  @Model('content', { default: [] }) content

  @Prop(Array) values

  filter = ''
  selected = this.content

  get filteredValues () {
    return _.filter(_.compose([_.includes(_.toLower(this.filter)), _.toLower]), this.values)
  }

  @Watch('selected')
  onSelectedChanged () {
    this.$emit('content', this.selected)
  }

  isOptionDisplayed (value) {
    return _.includes(value, this.filteredValues)
  }
}
</script>
